/* CommandLine.c generated by valac 0.56.3, the Vala compiler
 * generated from CommandLine.vala, do not modify */

/* CommandLine.vala
 *
 * Copyright 2022 Paulo Queiroz <pvaqueiroz@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <gobject/gvaluecollector.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TERMINAL_TYPE_COMMAND_LINE_OPTIONS (terminal_command_line_options_get_type ())
typedef struct _TerminalCommandLineOptions TerminalCommandLineOptions;
#define _g_free0(var) (var = (g_free (var), NULL))

#define TERMINAL_TYPE_COMMAND_LINE (terminal_command_line_get_type ())
#define TERMINAL_COMMAND_LINE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_COMMAND_LINE, TerminalCommandLine))
#define TERMINAL_COMMAND_LINE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_COMMAND_LINE, TerminalCommandLineClass))
#define TERMINAL_IS_COMMAND_LINE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_COMMAND_LINE))
#define TERMINAL_IS_COMMAND_LINE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_COMMAND_LINE))
#define TERMINAL_COMMAND_LINE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_COMMAND_LINE, TerminalCommandLineClass))

typedef struct _TerminalCommandLine TerminalCommandLine;
typedef struct _TerminalCommandLineClass TerminalCommandLineClass;
typedef struct _TerminalCommandLinePrivate TerminalCommandLinePrivate;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_option_context_free0(var) ((var == NULL) ? NULL : (var = (g_option_context_free (var), NULL)))
typedef struct _TerminalParamSpecCommandLine TerminalParamSpecCommandLine;

struct _TerminalCommandLineOptions {
	gchar* command;
	gchar* current_working_dir;
	gboolean version;
	gboolean help;
};

struct _TerminalCommandLine {
	GTypeInstance parent_instance;
	volatile int ref_count;
	TerminalCommandLinePrivate * priv;
};

struct _TerminalCommandLineClass {
	GTypeClass parent_class;
	void (*finalize) (TerminalCommandLine *self);
};

struct _TerminalParamSpecCommandLine {
	GParamSpec parent_instance;
};

static gpointer terminal_command_line_parent_class = NULL;

VALA_EXTERN GType terminal_command_line_options_get_type (void) G_GNUC_CONST ;
VALA_EXTERN TerminalCommandLineOptions* terminal_command_line_options_dup (const TerminalCommandLineOptions* self);
VALA_EXTERN void terminal_command_line_options_free (TerminalCommandLineOptions* self);
VALA_EXTERN void terminal_command_line_options_copy (const TerminalCommandLineOptions* self,
                                         TerminalCommandLineOptions* dest);
VALA_EXTERN void terminal_command_line_options_destroy (TerminalCommandLineOptions* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (TerminalCommandLineOptions, terminal_command_line_options_destroy)
VALA_EXTERN gpointer terminal_command_line_ref (gpointer instance);
VALA_EXTERN void terminal_command_line_unref (gpointer instance);
VALA_EXTERN GParamSpec* terminal_param_spec_command_line (const gchar* name,
                                              const gchar* nick,
                                              const gchar* blurb,
                                              GType object_type,
                                              GParamFlags flags);
VALA_EXTERN void terminal_value_set_command_line (GValue* value,
                                      gpointer v_object);
VALA_EXTERN void terminal_value_take_command_line (GValue* value,
                                       gpointer v_object);
VALA_EXTERN gpointer terminal_value_get_command_line (const GValue* value);
VALA_EXTERN GType terminal_command_line_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalCommandLine, terminal_command_line_unref)
VALA_EXTERN gboolean terminal_command_line_parse_command_line (GApplicationCommandLine* cmd,
                                                   TerminalCommandLineOptions* options);
static void _vala_array_add1 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add2 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
VALA_EXTERN TerminalCommandLine* terminal_command_line_new (void);
VALA_EXTERN TerminalCommandLine* terminal_command_line_construct (GType object_type);
static void terminal_command_line_finalize (TerminalCommandLine * obj);
static GType terminal_command_line_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

void
terminal_command_line_options_copy (const TerminalCommandLineOptions* self,
                                    TerminalCommandLineOptions* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	_tmp0_ = (*self).command;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 ((*dest).command);
	(*dest).command = _tmp1_;
	_tmp2_ = (*self).current_working_dir;
	_tmp3_ = g_strdup (_tmp2_);
	_g_free0 ((*dest).current_working_dir);
	(*dest).current_working_dir = _tmp3_;
	(*dest).version = (*self).version;
	(*dest).help = (*self).help;
}

void
terminal_command_line_options_destroy (TerminalCommandLineOptions* self)
{
	_g_free0 ((*self).command);
	_g_free0 ((*self).current_working_dir);
}

TerminalCommandLineOptions*
terminal_command_line_options_dup (const TerminalCommandLineOptions* self)
{
	TerminalCommandLineOptions* dup;
	dup = g_new0 (TerminalCommandLineOptions, 1);
	terminal_command_line_options_copy (self, dup);
	return dup;
}

void
terminal_command_line_options_free (TerminalCommandLineOptions* self)
{
	terminal_command_line_options_destroy (self);
	g_free (self);
}

static GType
terminal_command_line_options_get_type_once (void)
{
	GType terminal_command_line_options_type_id;
	terminal_command_line_options_type_id = g_boxed_type_register_static ("TerminalCommandLineOptions", (GBoxedCopyFunc) terminal_command_line_options_dup, (GBoxedFreeFunc) terminal_command_line_options_free);
	return terminal_command_line_options_type_id;
}

GType
terminal_command_line_options_get_type (void)
{
	static volatile gsize terminal_command_line_options_type_id__once = 0;
	if (g_once_init_enter (&terminal_command_line_options_type_id__once)) {
		GType terminal_command_line_options_type_id;
		terminal_command_line_options_type_id = terminal_command_line_options_get_type_once ();
		g_once_init_leave (&terminal_command_line_options_type_id__once, terminal_command_line_options_type_id);
	}
	return terminal_command_line_options_type_id__once;
}

static void
_vala_array_add1 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add2 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result;
	if (separator == NULL) {
		separator = "";
	}
	if (str_array != NULL) {
		gboolean _tmp1_ = FALSE;
		if (str_array_length1 > 0) {
			_tmp1_ = TRUE;
		} else {
			gboolean _tmp2_ = FALSE;
			if (str_array_length1 == -1) {
				const gchar* _tmp3_;
				_tmp3_ = str_array[0];
				_tmp2_ = _tmp3_ != NULL;
			} else {
				_tmp2_ = FALSE;
			}
			_tmp1_ = _tmp2_;
		}
		_tmp0_ = _tmp1_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		void* ptr = NULL;
		const gchar* _tmp22_;
		void* _tmp23_;
		const gchar* _tmp33_;
		len = (gsize) 1;
		{
			gboolean _tmp4_ = FALSE;
			i = 0;
			_tmp4_ = TRUE;
			while (TRUE) {
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
				if (!_tmp4_) {
					gint _tmp5_;
					_tmp5_ = i;
					i = _tmp5_ + 1;
				}
				_tmp4_ = FALSE;
				if (str_array_length1 != -1) {
					_tmp7_ = i < str_array_length1;
				} else {
					_tmp7_ = FALSE;
				}
				if (_tmp7_) {
					_tmp6_ = TRUE;
				} else {
					gboolean _tmp8_ = FALSE;
					if (str_array_length1 == -1) {
						const gchar* _tmp9_;
						_tmp9_ = str_array[i];
						_tmp8_ = _tmp9_ != NULL;
					} else {
						_tmp8_ = FALSE;
					}
					_tmp6_ = _tmp8_;
				}
				if (!_tmp6_) {
					break;
				}
				_tmp11_ = str_array[i];
				if (_tmp11_ != NULL) {
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
					_tmp12_ = str_array[i];
					_tmp13_ = strlen ((const gchar*) _tmp12_);
					_tmp14_ = _tmp13_;
					_tmp10_ = _tmp14_;
				} else {
					_tmp10_ = 0;
				}
				len += (gsize) _tmp10_;
			}
		}
		if (i == 0) {
			gchar* _tmp15_;
			_tmp15_ = g_strdup ("");
			result = _tmp15_;
			return result;
		}
		str_array_length1 = i;
		_tmp16_ = strlen ((const gchar*) separator);
		_tmp17_ = _tmp16_;
		len += (gsize) (_tmp17_ * (i - 1));
		_tmp18_ = g_malloc (len);
		res = _tmp18_;
		_tmp20_ = str_array[0];
		if (_tmp20_ != NULL) {
			const gchar* _tmp21_;
			_tmp21_ = str_array[0];
			_tmp19_ = (const gchar*) _tmp21_;
		} else {
			_tmp19_ = "";
		}
		_tmp22_ = res;
		_tmp23_ = g_stpcpy ((void*) _tmp22_, _tmp19_);
		ptr = _tmp23_;
		{
			gboolean _tmp24_ = FALSE;
			i = 1;
			_tmp24_ = TRUE;
			while (TRUE) {
				void* _tmp26_;
				void* _tmp27_;
				const gchar* _tmp28_ = NULL;
				const gchar* _tmp29_;
				void* _tmp31_;
				void* _tmp32_;
				if (!_tmp24_) {
					gint _tmp25_;
					_tmp25_ = i;
					i = _tmp25_ + 1;
				}
				_tmp24_ = FALSE;
				if (!(i < str_array_length1)) {
					break;
				}
				_tmp26_ = ptr;
				_tmp27_ = g_stpcpy (_tmp26_, (const gchar*) separator);
				ptr = _tmp27_;
				_tmp29_ = str_array[i];
				if (_tmp29_ != NULL) {
					const gchar* _tmp30_;
					_tmp30_ = str_array[i];
					_tmp28_ = (const gchar*) _tmp30_;
				} else {
					_tmp28_ = "";
				}
				_tmp31_ = ptr;
				_tmp32_ = g_stpcpy (_tmp31_, _tmp28_);
				ptr = _tmp32_;
			}
		}
		_tmp33_ = res;
		res = NULL;
		result = (gchar*) _tmp33_;
		return result;
	} else {
		gchar* _tmp34_;
		_tmp34_ = g_strdup ("");
		result = _tmp34_;
		return result;
	}
}

gboolean
terminal_command_line_parse_command_line (GApplicationCommandLine* cmd,
                                          TerminalCommandLineOptions* options)
{
	TerminalCommandLineOptions _vala_options = {0};
	TerminalCommandLineOptions _tmp0_ = {0};
	GOptionEntry* option_entries = NULL;
	GOptionEntry _tmp1_ = {0};
	GOptionEntry _tmp2_ = {0};
	GOptionEntry _tmp3_ = {0};
	GOptionEntry _tmp4_ = {0};
	GOptionEntry* _tmp5_;
	gint option_entries_length1;
	gint _option_entries_size_;
	GOptionContext* ctx = NULL;
	GOptionContext* _tmp6_;
	GOptionContext* _tmp7_;
	GOptionContext* _tmp8_;
	GOptionEntry* _tmp9_;
	gint _tmp9__length1;
	gchar** original_argv = NULL;
	gint _tmp10_ = 0;
	gchar** _tmp11_;
	gint original_argv_length1;
	gint _original_argv_size_;
	gchar** real_argv = NULL;
	gchar** _tmp12_;
	gint real_argv_length1;
	gint _real_argv_size_;
	gchar** commandv = NULL;
	gchar** _tmp13_;
	gint commandv_length1;
	gint _commandv_size_;
	gboolean dd = FALSE;
	gchar** _tmp14_;
	gint _tmp14__length1;
	GError* _inner_error0_ = NULL;
	gboolean result;
	g_return_val_if_fail (cmd != NULL, FALSE);
	terminal_command_line_options_destroy (&_vala_options);
	_vala_options = _tmp0_;
	memset (&_tmp1_, 0, sizeof (GOptionEntry));
	_tmp1_.long_name = "version";
	_tmp1_.short_name = 'v';
	_tmp1_.description = _ ("Show app version");
	_tmp1_.flags = (gint) G_OPTION_FLAG_NONE;
	_tmp1_.arg = G_OPTION_ARG_NONE;
	_tmp1_.arg_data = &_vala_options.version;
	_tmp1_.arg_description = NULL;
	memset (&_tmp2_, 0, sizeof (GOptionEntry));
	_tmp2_.long_name = "working-directory";
	_tmp2_.short_name = 'w';
	_tmp2_.description = _ ("Set current working directory");
	_tmp2_.flags = (gint) G_OPTION_FLAG_NONE;
	_tmp2_.arg = G_OPTION_ARG_FILENAME;
	_tmp2_.arg_data = &_vala_options.current_working_dir;
	_tmp2_.arg_description = NULL;
	memset (&_tmp3_, 0, sizeof (GOptionEntry));
	_tmp3_.long_name = "command";
	_tmp3_.short_name = 'c';
	_tmp3_.description = _ ("Execute command in a terminal");
	_tmp3_.flags = (gint) G_OPTION_FLAG_NONE;
	_tmp3_.arg = G_OPTION_ARG_STRING;
	_tmp3_.arg_data = &_vala_options.command;
	_tmp3_.arg_description = NULL;
	memset (&_tmp4_, 0, sizeof (GOptionEntry));
	_tmp4_.long_name = "help";
	_tmp4_.short_name = 'h';
	_tmp4_.description = _ ("Show help");
	_tmp4_.flags = (gint) G_OPTION_FLAG_NONE;
	_tmp4_.arg = G_OPTION_ARG_NONE;
	_tmp4_.arg_data = &_vala_options.help;
	_tmp4_.arg_description = NULL;
	_tmp5_ = g_new0 (GOptionEntry, 4);
	_tmp5_[0] = _tmp1_;
	_tmp5_[1] = _tmp2_;
	_tmp5_[2] = _tmp3_;
	_tmp5_[3] = _tmp4_;
	option_entries = _tmp5_;
	option_entries_length1 = 4;
	_option_entries_size_ = option_entries_length1;
	_tmp6_ = g_option_context_new ("[-- COMMAND ...]");
	ctx = _tmp6_;
	_tmp7_ = ctx;
	g_option_context_set_help_enabled (_tmp7_, FALSE);
	_tmp8_ = ctx;
	_tmp9_ = option_entries;
	_tmp9__length1 = option_entries_length1;
	g_option_context_add_main_entries (_tmp8_, _tmp9_, NULL);
	_tmp11_ = g_application_command_line_get_arguments (cmd, &_tmp10_);
	original_argv = _tmp11_;
	original_argv_length1 = _tmp10_;
	_original_argv_size_ = original_argv_length1;
	_tmp12_ = g_new0 (gchar*, 0 + 1);
	real_argv = _tmp12_;
	real_argv_length1 = 0;
	_real_argv_size_ = real_argv_length1;
	_tmp13_ = g_new0 (gchar*, 0 + 1);
	commandv = _tmp13_;
	commandv_length1 = 0;
	_commandv_size_ = commandv_length1;
	dd = FALSE;
	_tmp14_ = original_argv;
	_tmp14__length1 = original_argv_length1;
	{
		gchar** s_collection = NULL;
		gint s_collection_length1 = 0;
		gint _s_collection_size_ = 0;
		gint s_it = 0;
		s_collection = _tmp14_;
		s_collection_length1 = _tmp14__length1;
		for (s_it = 0; s_it < s_collection_length1; s_it = s_it + 1) {
			const gchar* s = NULL;
			s = s_collection[s_it];
			{
				if (dd) {
					const gchar* _tmp15_;
					gchar* _tmp16_;
					_tmp15_ = s;
					_tmp16_ = g_strdup (_tmp15_);
					_vala_array_add1 (&commandv, &commandv_length1, &_commandv_size_, _tmp16_);
				} else {
					const gchar* _tmp17_;
					_tmp17_ = s;
					if (g_strcmp0 (_tmp17_, "--") == 0) {
						dd = TRUE;
					} else {
						const gchar* _tmp18_;
						gchar* _tmp19_;
						_tmp18_ = s;
						_tmp19_ = g_strdup (_tmp18_);
						_vala_array_add2 (&real_argv, &real_argv_length1, &_real_argv_size_, _tmp19_);
					}
				}
			}
		}
	}
	{
		GOptionContext* _tmp20_;
		TerminalCommandLineOptions _tmp21_;
		gboolean _tmp25_ = FALSE;
		_tmp20_ = ctx;
		g_option_context_parse_strv (_tmp20_, &real_argv, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp21_ = _vala_options;
		if (_tmp21_.help) {
			GOptionContext* _tmp22_;
			gchar* _tmp23_;
			gchar* _tmp24_;
			_tmp22_ = ctx;
			_tmp23_ = g_option_context_get_help (_tmp22_, TRUE, NULL);
			_tmp24_ = _tmp23_;
			G_TYPE_INSTANCE_GET_CLASS (cmd, g_application_command_line_get_type (), GApplicationCommandLineClass)->print_literal (cmd, _tmp24_);
			_g_free0 (_tmp24_);
		}
		if (dd) {
			TerminalCommandLineOptions _tmp26_;
			const gchar* _tmp27_;
			_tmp26_ = _vala_options;
			_tmp27_ = _tmp26_.command;
			_tmp25_ = _tmp27_ == NULL;
		} else {
			_tmp25_ = FALSE;
		}
		if (_tmp25_) {
			gchar** _tmp28_;
			gint _tmp28__length1;
			gchar* _tmp29_;
			_tmp28_ = commandv;
			_tmp28__length1 = commandv_length1;
			_tmp29_ = _vala_g_strjoinv (" ", _tmp28_, (gint) _tmp28__length1);
			_g_free0 (_vala_options.command);
			_vala_options.command = _tmp29_;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp30_;
		const gchar* _tmp31_;
		gchar** _tmp32_;
		gint _tmp32__length1;
		const gchar* _tmp33_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp30_ = e;
		_tmp31_ = _tmp30_->message;
		g_application_command_line_printerr (cmd, "%s\n", _tmp31_);
		_tmp32_ = original_argv;
		_tmp32__length1 = original_argv_length1;
		_tmp33_ = _tmp32_[0];
		g_application_command_line_printerr (cmd, _ ("Run %s --help to get help\n"), _tmp33_);
		result = FALSE;
		_g_error_free0 (e);
		commandv = (_vala_array_free (commandv, commandv_length1, (GDestroyNotify) g_free), NULL);
		real_argv = (_vala_array_free (real_argv, real_argv_length1, (GDestroyNotify) g_free), NULL);
		original_argv = (_vala_array_free (original_argv, original_argv_length1, (GDestroyNotify) g_free), NULL);
		_g_option_context_free0 (ctx);
		option_entries = (g_free (option_entries), NULL);
		if (options) {
			*options = _vala_options;
		} else {
			terminal_command_line_options_destroy (&_vala_options);
		}
		return result;
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gboolean _tmp34_ = FALSE;
		commandv = (_vala_array_free (commandv, commandv_length1, (GDestroyNotify) g_free), NULL);
		real_argv = (_vala_array_free (real_argv, real_argv_length1, (GDestroyNotify) g_free), NULL);
		original_argv = (_vala_array_free (original_argv, original_argv_length1, (GDestroyNotify) g_free), NULL);
		_g_option_context_free0 (ctx);
		option_entries = (g_free (option_entries), NULL);
		terminal_command_line_options_destroy (&_vala_options);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp34_;
	}
	result = TRUE;
	commandv = (_vala_array_free (commandv, commandv_length1, (GDestroyNotify) g_free), NULL);
	real_argv = (_vala_array_free (real_argv, real_argv_length1, (GDestroyNotify) g_free), NULL);
	original_argv = (_vala_array_free (original_argv, original_argv_length1, (GDestroyNotify) g_free), NULL);
	_g_option_context_free0 (ctx);
	option_entries = (g_free (option_entries), NULL);
	if (options) {
		*options = _vala_options;
	} else {
		terminal_command_line_options_destroy (&_vala_options);
	}
	return result;
}

TerminalCommandLine*
terminal_command_line_construct (GType object_type)
{
	TerminalCommandLine* self = NULL;
	self = (TerminalCommandLine*) g_type_create_instance (object_type);
	return self;
}

TerminalCommandLine*
terminal_command_line_new (void)
{
	return terminal_command_line_construct (TERMINAL_TYPE_COMMAND_LINE);
}

static void
terminal_value_command_line_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}

static void
terminal_value_command_line_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		terminal_command_line_unref (value->data[0].v_pointer);
	}
}

static void
terminal_value_command_line_copy_value (const GValue* src_value,
                                        GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = terminal_command_line_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}

static gpointer
terminal_value_command_line_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}

static gchar*
terminal_value_command_line_collect_value (GValue* value,
                                           guint n_collect_values,
                                           GTypeCValue* collect_values,
                                           guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		TerminalCommandLine * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = terminal_command_line_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}

static gchar*
terminal_value_command_line_lcopy_value (const GValue* value,
                                         guint n_collect_values,
                                         GTypeCValue* collect_values,
                                         guint collect_flags)
{
	TerminalCommandLine ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = terminal_command_line_ref (value->data[0].v_pointer);
	}
	return NULL;
}

GParamSpec*
terminal_param_spec_command_line (const gchar* name,
                                  const gchar* nick,
                                  const gchar* blurb,
                                  GType object_type,
                                  GParamFlags flags)
{
	TerminalParamSpecCommandLine* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TERMINAL_TYPE_COMMAND_LINE), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}

gpointer
terminal_value_get_command_line (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TERMINAL_TYPE_COMMAND_LINE), NULL);
	return value->data[0].v_pointer;
}

void
terminal_value_set_command_line (GValue* value,
                                 gpointer v_object)
{
	TerminalCommandLine * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TERMINAL_TYPE_COMMAND_LINE));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TERMINAL_TYPE_COMMAND_LINE));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		terminal_command_line_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		terminal_command_line_unref (old);
	}
}

void
terminal_value_take_command_line (GValue* value,
                                  gpointer v_object)
{
	TerminalCommandLine * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TERMINAL_TYPE_COMMAND_LINE));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TERMINAL_TYPE_COMMAND_LINE));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		terminal_command_line_unref (old);
	}
}

static void
terminal_command_line_class_init (TerminalCommandLineClass * klass,
                                  gpointer klass_data)
{
	terminal_command_line_parent_class = g_type_class_peek_parent (klass);
	((TerminalCommandLineClass *) klass)->finalize = terminal_command_line_finalize;
}

static void
terminal_command_line_instance_init (TerminalCommandLine * self,
                                     gpointer klass)
{
	self->ref_count = 1;
}

static void
terminal_command_line_finalize (TerminalCommandLine * obj)
{
	TerminalCommandLine * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TERMINAL_TYPE_COMMAND_LINE, TerminalCommandLine);
	g_signal_handlers_destroy (self);
}

static GType
terminal_command_line_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { terminal_value_command_line_init, terminal_value_command_line_free_value, terminal_value_command_line_copy_value, terminal_value_command_line_peek_pointer, "p", terminal_value_command_line_collect_value, "p", terminal_value_command_line_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (TerminalCommandLineClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) terminal_command_line_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TerminalCommandLine), 0, (GInstanceInitFunc) terminal_command_line_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType terminal_command_line_type_id;
	terminal_command_line_type_id = g_type_register_fundamental (g_type_fundamental_next (), "TerminalCommandLine", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return terminal_command_line_type_id;
}

GType
terminal_command_line_get_type (void)
{
	static volatile gsize terminal_command_line_type_id__once = 0;
	if (g_once_init_enter (&terminal_command_line_type_id__once)) {
		GType terminal_command_line_type_id;
		terminal_command_line_type_id = terminal_command_line_get_type_once ();
		g_once_init_leave (&terminal_command_line_type_id__once, terminal_command_line_type_id);
	}
	return terminal_command_line_type_id__once;
}

gpointer
terminal_command_line_ref (gpointer instance)
{
	TerminalCommandLine * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}

void
terminal_command_line_unref (gpointer instance)
{
	TerminalCommandLine * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		TERMINAL_COMMAND_LINE_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

