/* Dialogs.c generated by valac 0.56.3, the Vala compiler
 * generated from Dialogs.vala, do not modify */

/* Dialogs.vala
 *
 * Copyright 2023 Paulo Queiroz <pvaqueiroz@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>
#include <adwaita.h>
#include <gtk/gtk.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	TERMINAL_CONFIRM_ACTION_TYPE_NO_YES,
	TERMINAL_CONFIRM_ACTION_TYPE_CANCEL_OK,
	TERMINAL_CONFIRM_ACTION_TYPE_KEEP_REPLACE
} TerminalConfirmActionType;

#define TERMINAL_TYPE_CONFIRM_ACTION_TYPE (terminal_confirm_action_type_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block14Data Block14Data;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _TerminalConfirmActionData TerminalConfirmActionData;

struct _Block14Data {
	int _ref_count_;
	gboolean response;
	GSourceFunc callback;
	gpointer callback_target;
	GDestroyNotify callback_target_destroy_notify;
	gchar** values;
	gint values_length1;
	gint _values_size_;
	gpointer _async_data_;
};

struct _TerminalConfirmActionData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	gchar* title;
	gchar* body;
	TerminalConfirmActionType confirm_type;
	AdwResponseAppearance appearance1;
	AdwResponseAppearance appearance2;
	gboolean result;
	Block14Data* _data14_;
	gchar** labels;
	gint _tmp0_;
	gchar** _tmp1_;
	gint labels_length1;
	gint _labels_size_;
	gint _tmp2_;
	gchar** _tmp3_;
	GtkApplication* _tmp4_;
	GApplication* _tmp5_;
	GtkWindow* _tmp6_;
	GtkWindow* _tmp7_;
	AdwMessageDialog* d;
	gchar** _tmp8_;
	gint _tmp8__length1;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar** _tmp11_;
	gint _tmp11__length1;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	AdwMessageDialog* _tmp14_;
	gchar** _tmp15_;
	gint _tmp15__length1;
	const gchar* _tmp16_;
	gchar** _tmp17_;
	gint _tmp17__length1;
	const gchar* _tmp18_;
	gchar** _tmp19_;
	gint _tmp19__length1;
	const gchar* _tmp20_;
	gchar** _tmp21_;
	gint _tmp21__length1;
	const gchar* _tmp22_;
	gchar** _tmp23_;
	gint _tmp23__length1;
	const gchar* _tmp24_;
	gchar** _tmp25_;
	gint _tmp25__length1;
	const gchar* _tmp26_;
};

VALA_EXTERN GType terminal_confirm_action_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gchar** terminal_confirm_action_type_get_labels (TerminalConfirmActionType self,
                                                 gint* result_length1);
VALA_EXTERN gchar** terminal_confirm_action_type_get_values (TerminalConfirmActionType self,
                                                 gint* result_length1);
static void terminal_confirm_action_data_free (gpointer _data);
VALA_EXTERN void terminal_confirm_action (const gchar* title,
                              const gchar* body,
                              TerminalConfirmActionType confirm_type,
                              AdwResponseAppearance appearance1,
                              AdwResponseAppearance appearance2,
                              GAsyncReadyCallback _callback_,
                              gpointer _user_data_);
VALA_EXTERN gboolean terminal_confirm_action_finish (GAsyncResult* _res_);
static gboolean terminal_confirm_action_co (TerminalConfirmActionData* _data_);
static Block14Data* block14_data_ref (Block14Data* _data14_);
static void block14_data_unref (void * _userdata_);
static gboolean _terminal_confirm_action_co_gsource_func (gpointer self);
static void __lambda38_ (Block14Data* _data14_,
                  const gchar* _response);
static void ___lambda38__adw_message_dialog_response (AdwMessageDialog* _sender,
                                               const gchar* response,
                                               gpointer self);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

gchar**
terminal_confirm_action_type_get_labels (TerminalConfirmActionType self,
                                         gint* result_length1)
{
	gchar** result;
	switch (self) {
		case TERMINAL_CONFIRM_ACTION_TYPE_NO_YES:
		{
			gchar* _tmp0_;
			gchar* _tmp1_;
			gchar** _tmp2_;
			gchar** _tmp3_;
			gint _tmp3__length1;
			_tmp0_ = g_strdup (_ ("No"));
			_tmp1_ = g_strdup (_ ("Yes"));
			_tmp2_ = g_new0 (gchar*, 2 + 1);
			_tmp2_[0] = _tmp0_;
			_tmp2_[1] = _tmp1_;
			_tmp3_ = _tmp2_;
			_tmp3__length1 = 2;
			if (result_length1) {
				*result_length1 = _tmp3__length1;
			}
			result = _tmp3_;
			return result;
		}
		case TERMINAL_CONFIRM_ACTION_TYPE_CANCEL_OK:
		{
			gchar* _tmp4_;
			gchar* _tmp5_;
			gchar** _tmp6_;
			gchar** _tmp7_;
			gint _tmp7__length1;
			_tmp4_ = g_strdup (_ ("Cancel"));
			_tmp5_ = g_strdup (_ ("Ok"));
			_tmp6_ = g_new0 (gchar*, 2 + 1);
			_tmp6_[0] = _tmp4_;
			_tmp6_[1] = _tmp5_;
			_tmp7_ = _tmp6_;
			_tmp7__length1 = 2;
			if (result_length1) {
				*result_length1 = _tmp7__length1;
			}
			result = _tmp7_;
			return result;
		}
		case TERMINAL_CONFIRM_ACTION_TYPE_KEEP_REPLACE:
		{
			gchar* _tmp8_;
			gchar* _tmp9_;
			gchar** _tmp10_;
			gchar** _tmp11_;
			gint _tmp11__length1;
			_tmp8_ = g_strdup (_ ("Keep"));
			_tmp9_ = g_strdup (_ ("Replace"));
			_tmp10_ = g_new0 (gchar*, 2 + 1);
			_tmp10_[0] = _tmp8_;
			_tmp10_[1] = _tmp9_;
			_tmp11_ = _tmp10_;
			_tmp11__length1 = 2;
			if (result_length1) {
				*result_length1 = _tmp11__length1;
			}
			result = _tmp11_;
			return result;
		}
		default:
		break;
	}
	g_error ("Dialogs.vala:33: Invalid ConfirmActionType %d", (gint) self);
}

gchar**
terminal_confirm_action_type_get_values (TerminalConfirmActionType self,
                                         gint* result_length1)
{
	gchar** result;
	switch (self) {
		case TERMINAL_CONFIRM_ACTION_TYPE_NO_YES:
		{
			gchar* _tmp0_;
			gchar* _tmp1_;
			gchar** _tmp2_;
			gchar** _tmp3_;
			gint _tmp3__length1;
			_tmp0_ = g_strdup ("no");
			_tmp1_ = g_strdup ("yes");
			_tmp2_ = g_new0 (gchar*, 2 + 1);
			_tmp2_[0] = _tmp0_;
			_tmp2_[1] = _tmp1_;
			_tmp3_ = _tmp2_;
			_tmp3__length1 = 2;
			if (result_length1) {
				*result_length1 = _tmp3__length1;
			}
			result = _tmp3_;
			return result;
		}
		case TERMINAL_CONFIRM_ACTION_TYPE_CANCEL_OK:
		{
			gchar* _tmp4_;
			gchar* _tmp5_;
			gchar** _tmp6_;
			gchar** _tmp7_;
			gint _tmp7__length1;
			_tmp4_ = g_strdup ("cancel");
			_tmp5_ = g_strdup ("ok");
			_tmp6_ = g_new0 (gchar*, 2 + 1);
			_tmp6_[0] = _tmp4_;
			_tmp6_[1] = _tmp5_;
			_tmp7_ = _tmp6_;
			_tmp7__length1 = 2;
			if (result_length1) {
				*result_length1 = _tmp7__length1;
			}
			result = _tmp7_;
			return result;
		}
		case TERMINAL_CONFIRM_ACTION_TYPE_KEEP_REPLACE:
		{
			gchar* _tmp8_;
			gchar* _tmp9_;
			gchar** _tmp10_;
			gchar** _tmp11_;
			gint _tmp11__length1;
			_tmp8_ = g_strdup ("keep");
			_tmp9_ = g_strdup ("replace");
			_tmp10_ = g_new0 (gchar*, 2 + 1);
			_tmp10_[0] = _tmp8_;
			_tmp10_[1] = _tmp9_;
			_tmp11_ = _tmp10_;
			_tmp11__length1 = 2;
			if (result_length1) {
				*result_length1 = _tmp11__length1;
			}
			result = _tmp11_;
			return result;
		}
		default:
		break;
	}
	g_error ("Dialogs.vala:42: Invalid ConfirmActionType %d", (gint) self);
}

static GType
terminal_confirm_action_type_get_type_once (void)
{
	static const GEnumValue values[] = {{TERMINAL_CONFIRM_ACTION_TYPE_NO_YES, "TERMINAL_CONFIRM_ACTION_TYPE_NO_YES", "no-yes"}, {TERMINAL_CONFIRM_ACTION_TYPE_CANCEL_OK, "TERMINAL_CONFIRM_ACTION_TYPE_CANCEL_OK", "cancel-ok"}, {TERMINAL_CONFIRM_ACTION_TYPE_KEEP_REPLACE, "TERMINAL_CONFIRM_ACTION_TYPE_KEEP_REPLACE", "keep-replace"}, {0, NULL, NULL}};
	GType terminal_confirm_action_type_type_id;
	terminal_confirm_action_type_type_id = g_enum_register_static ("TerminalConfirmActionType", values);
	return terminal_confirm_action_type_type_id;
}

GType
terminal_confirm_action_type_get_type (void)
{
	static volatile gsize terminal_confirm_action_type_type_id__once = 0;
	if (g_once_init_enter (&terminal_confirm_action_type_type_id__once)) {
		GType terminal_confirm_action_type_type_id;
		terminal_confirm_action_type_type_id = terminal_confirm_action_type_get_type_once ();
		g_once_init_leave (&terminal_confirm_action_type_type_id__once, terminal_confirm_action_type_type_id);
	}
	return terminal_confirm_action_type_type_id__once;
}

static void
terminal_confirm_action_data_free (gpointer _data)
{
	TerminalConfirmActionData* _data_;
	_data_ = _data;
	_g_free0 (_data_->title);
	_g_free0 (_data_->body);
	g_slice_free (TerminalConfirmActionData, _data_);
}

void
terminal_confirm_action (const gchar* title,
                         const gchar* body,
                         TerminalConfirmActionType confirm_type,
                         AdwResponseAppearance appearance1,
                         AdwResponseAppearance appearance2,
                         GAsyncReadyCallback _callback_,
                         gpointer _user_data_)
{
	TerminalConfirmActionData* _data_;
	gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (title != NULL);
	g_return_if_fail (body != NULL);
	_data_ = g_slice_new0 (TerminalConfirmActionData);
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, terminal_confirm_action_data_free);
	_tmp0_ = g_strdup (title);
	_g_free0 (_data_->title);
	_data_->title = _tmp0_;
	_tmp1_ = g_strdup (body);
	_g_free0 (_data_->body);
	_data_->body = _tmp1_;
	_data_->confirm_type = confirm_type;
	_data_->appearance1 = appearance1;
	_data_->appearance2 = appearance2;
	terminal_confirm_action_co (_data_);
}

gboolean
terminal_confirm_action_finish (GAsyncResult* _res_)
{
	gboolean result;
	TerminalConfirmActionData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
	result = _data_->result;
	return result;
}

static Block14Data*
block14_data_ref (Block14Data* _data14_)
{
	g_atomic_int_inc (&_data14_->_ref_count_);
	return _data14_;
}

static void
block14_data_unref (void * _userdata_)
{
	Block14Data* _data14_;
	_data14_ = (Block14Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data14_->_ref_count_)) {
		_data14_->values = (_vala_array_free (_data14_->values, _data14_->values_length1, (GDestroyNotify) g_free), NULL);
		(_data14_->callback_target_destroy_notify == NULL) ? NULL : (_data14_->callback_target_destroy_notify (_data14_->callback_target), NULL);
		_data14_->callback = NULL;
		_data14_->callback_target = NULL;
		_data14_->callback_target_destroy_notify = NULL;
		g_slice_free (Block14Data, _data14_);
	}
}

static gboolean
_terminal_confirm_action_co_gsource_func (gpointer self)
{
	gboolean result;
	result = terminal_confirm_action_co (self);
	return result;
}

static void
__lambda38_ (Block14Data* _data14_,
             const gchar* _response)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
	const gchar* _tmp1_;
	GSourceFunc _tmp2_;
	gpointer _tmp2__target;
	g_return_if_fail (_response != NULL);
	_tmp0_ = _data14_->values;
	_tmp0__length1 = _data14_->values_length1;
	_tmp1_ = _tmp0_[1];
	_data14_->response = g_strcmp0 (_response, _tmp1_) == 0;
	_tmp2_ = _data14_->callback;
	_tmp2__target = _data14_->callback_target;
	_tmp2_ (_tmp2__target);
}

static void
___lambda38__adw_message_dialog_response (AdwMessageDialog* _sender,
                                          const gchar* response,
                                          gpointer self)
{
	__lambda38_ (self, response);
}

static gboolean
terminal_confirm_action_co (TerminalConfirmActionData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_data14_ = g_slice_new0 (Block14Data);
	_data_->_data14_->_ref_count_ = 1;
	_data_->_data14_->_async_data_ = _data_;
	_data_->_data14_->response = FALSE;
	_data_->_data14_->callback = _terminal_confirm_action_co_gsource_func;
	_data_->_data14_->callback_target = _data_;
	_data_->_data14_->callback_target_destroy_notify = NULL;
	_data_->_tmp0_ = 0;
	_data_->_tmp1_ = terminal_confirm_action_type_get_labels (_data_->confirm_type, &_data_->_tmp0_);
	_data_->labels = _data_->_tmp1_;
	_data_->labels_length1 = _data_->_tmp0_;
	_data_->_labels_size_ = _data_->labels_length1;
	_data_->_tmp2_ = 0;
	_data_->_tmp3_ = terminal_confirm_action_type_get_values (_data_->confirm_type, &_data_->_tmp2_);
	_data_->_data14_->values = _data_->_tmp3_;
	_data_->_data14_->values_length1 = _data_->_tmp2_;
	_data_->_data14_->_values_size_ = _data_->_data14_->values_length1;
	_data_->_tmp5_ = g_application_get_default ();
	_data_->_tmp4_ = G_TYPE_CHECK_INSTANCE_TYPE (_data_->_tmp5_, gtk_application_get_type ()) ? ((GtkApplication*) _data_->_tmp5_) : NULL;
	_data_->_tmp6_ = NULL;
	if (_data_->_tmp4_ != NULL) {
		_data_->_tmp7_ = gtk_application_get_active_window (_data_->_tmp4_);
		_data_->_tmp6_ = _data_->_tmp7_;
	}
	_data_->_tmp8_ = _data_->_data14_->values;
	_data_->_tmp8__length1 = _data_->_data14_->values_length1;
	_data_->_tmp9_ = _data_->_tmp8_[1];
	_data_->_tmp10_ = g_strdup (_data_->_tmp9_);
	_data_->_tmp11_ = _data_->_data14_->values;
	_data_->_tmp11__length1 = _data_->_data14_->values_length1;
	_data_->_tmp12_ = _data_->_tmp11_[0];
	_data_->_tmp13_ = g_strdup (_data_->_tmp12_);
	_data_->_tmp14_ = NULL;
	_data_->_tmp14_ = (AdwMessageDialog*) adw_message_dialog_new (_data_->_tmp6_, _data_->title, _data_->body);
	adw_message_dialog_set_default_response (_data_->_tmp14_, _data_->_tmp10_);
	_g_free0 (_data_->_tmp10_);
	adw_message_dialog_set_close_response (_data_->_tmp14_, _data_->_tmp13_);
	_g_free0 (_data_->_tmp13_);
	g_object_ref_sink (_data_->_tmp14_);
	_data_->d = _data_->_tmp14_;
	_data_->_tmp15_ = _data_->_data14_->values;
	_data_->_tmp15__length1 = _data_->_data14_->values_length1;
	_data_->_tmp16_ = _data_->_tmp15_[0];
	_data_->_tmp17_ = _data_->labels;
	_data_->_tmp17__length1 = _data_->labels_length1;
	_data_->_tmp18_ = _data_->_tmp17_[0];
	adw_message_dialog_add_response (_data_->d, _data_->_tmp16_, _data_->_tmp18_);
	_data_->_tmp19_ = _data_->_data14_->values;
	_data_->_tmp19__length1 = _data_->_data14_->values_length1;
	_data_->_tmp20_ = _data_->_tmp19_[1];
	_data_->_tmp21_ = _data_->labels;
	_data_->_tmp21__length1 = _data_->labels_length1;
	_data_->_tmp22_ = _data_->_tmp21_[1];
	adw_message_dialog_add_response (_data_->d, _data_->_tmp20_, _data_->_tmp22_);
	_data_->_tmp23_ = _data_->_data14_->values;
	_data_->_tmp23__length1 = _data_->_data14_->values_length1;
	_data_->_tmp24_ = _data_->_tmp23_[0];
	adw_message_dialog_set_response_appearance (_data_->d, _data_->_tmp24_, _data_->appearance1);
	_data_->_tmp25_ = _data_->_data14_->values;
	_data_->_tmp25__length1 = _data_->_data14_->values_length1;
	_data_->_tmp26_ = _data_->_tmp25_[1];
	adw_message_dialog_set_response_appearance (_data_->d, _data_->_tmp26_, _data_->appearance2);
	g_signal_connect_data (_data_->d, "response", (GCallback) ___lambda38__adw_message_dialog_response, block14_data_ref (_data_->_data14_), (GClosureNotify) block14_data_unref, 0);
	gtk_widget_show ((GtkWidget*) _data_->d);
	_data_->_state_ = 1;
	return FALSE;
	_state_1:
	;
	_data_->result = _data_->_data14_->response;
	_g_object_unref0 (_data_->d);
	_data_->labels = (_vala_array_free (_data_->labels, _data_->labels_length1, (GDestroyNotify) g_free), NULL);
	block14_data_unref (_data_->_data14_);
	_data_->_data14_ = NULL;
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

