/* Terminal.c generated by valac 0.56.3, the Vala compiler
 * generated from Terminal.vala, do not modify */

#include <glib.h>
#include <glib/gstdio.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <vte/vte.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

VALA_EXTERN gboolean terminal_is_flatpak (void);
VALA_EXTERN gchar* terminal_fp_guess_shell (GCancellable* cancellable,
                                GError** error);
VALA_EXTERN gchar** terminal_fp_get_env (GCancellable* cancellable,
                             gint* result_length1,
                             GError** error);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

gboolean
terminal_is_flatpak (void)
{
	gboolean result;
	result = g_file_test ("/.flatpak-info", G_FILE_TEST_EXISTS);
	return result;
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	g_strstrip (_result_);
	result = _result_;
	return result;
}

gchar*
terminal_fp_guess_shell (GCancellable* cancellable,
                         GError** error)
{
	gchar** argv = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar** _tmp7_;
	gint argv_length1;
	gint _argv_size_;
	GSubprocessLauncher* launcher = NULL;
	GSubprocessLauncher* _tmp8_;
	GSubprocessLauncher* _tmp9_;
	GSubprocess* sp = NULL;
	GSubprocessLauncher* _tmp10_;
	gchar** _tmp11_;
	gint _tmp11__length1;
	GSubprocess* _tmp12_;
	GSubprocess* _tmp13_;
	gchar* buf = NULL;
	gboolean _tmp14_ = FALSE;
	GSubprocess* _tmp15_;
	gchar* _tmp16_ = NULL;
	gboolean _tmp17_;
	gchar** parts = NULL;
	const gchar* _tmp18_;
	gchar** _tmp19_;
	gchar** _tmp20_;
	gint parts_length1;
	gint _parts_size_;
	gchar** _tmp21_;
	gint _tmp21__length1;
	gchar** _tmp22_;
	gint _tmp22__length1;
	const gchar* _tmp23_;
	gchar* _tmp24_;
	GError* _inner_error0_ = NULL;
	gchar* result;
	if (!terminal_is_flatpak ()) {
		gchar* _tmp0_;
		_tmp0_ = vte_get_user_shell ();
		result = _tmp0_;
		return result;
	}
	_tmp1_ = g_strdup ("flatpak-spawn");
	_tmp2_ = g_strdup ("--host");
	_tmp3_ = g_strdup ("getent");
	_tmp4_ = g_strdup ("passwd");
	_tmp5_ = g_get_user_name ();
	_tmp6_ = g_strdup (_tmp5_);
	_tmp7_ = g_new0 (gchar*, 5 + 1);
	_tmp7_[0] = _tmp1_;
	_tmp7_[1] = _tmp2_;
	_tmp7_[2] = _tmp3_;
	_tmp7_[3] = _tmp4_;
	_tmp7_[4] = _tmp6_;
	argv = _tmp7_;
	argv_length1 = 5;
	_argv_size_ = argv_length1;
	_tmp8_ = g_subprocess_launcher_new (G_SUBPROCESS_FLAGS_STDOUT_PIPE | G_SUBPROCESS_FLAGS_STDERR_SILENCE);
	launcher = _tmp8_;
	_tmp9_ = launcher;
	g_subprocess_launcher_unsetenv (_tmp9_, "G_MESSAGES_DEBUG");
	_tmp10_ = launcher;
	_tmp11_ = argv;
	_tmp11__length1 = argv_length1;
	_tmp12_ = g_subprocess_launcher_spawnv (_tmp10_, _tmp11_, &_inner_error0_);
	sp = _tmp12_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_object_unref0 (launcher);
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
		return NULL;
	}
	_tmp13_ = sp;
	if (_tmp13_ == NULL) {
		result = NULL;
		_g_object_unref0 (sp);
		_g_object_unref0 (launcher);
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
		return result;
	}
	buf = NULL;
	_tmp15_ = sp;
	_tmp17_ = g_subprocess_communicate_utf8 (_tmp15_, NULL, cancellable, &_tmp16_, NULL, &_inner_error0_);
	_g_free0 (buf);
	buf = _tmp16_;
	_tmp14_ = _tmp17_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_free0 (buf);
		_g_object_unref0 (sp);
		_g_object_unref0 (launcher);
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
		return NULL;
	}
	if (!_tmp14_) {
		result = NULL;
		_g_free0 (buf);
		_g_object_unref0 (sp);
		_g_object_unref0 (launcher);
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
		return result;
	}
	_tmp18_ = buf;
	_tmp20_ = _tmp19_ = g_strsplit (_tmp18_, ":", 0);
	parts = _tmp20_;
	parts_length1 = _vala_array_length (_tmp19_);
	_parts_size_ = parts_length1;
	_tmp21_ = parts;
	_tmp21__length1 = parts_length1;
	if (_tmp21__length1 < 7) {
		result = NULL;
		parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
		_g_free0 (buf);
		_g_object_unref0 (sp);
		_g_object_unref0 (launcher);
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
		return result;
	}
	_tmp22_ = parts;
	_tmp22__length1 = parts_length1;
	_tmp23_ = _tmp22_[6];
	_tmp24_ = string_strip (_tmp23_);
	result = _tmp24_;
	parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
	_g_free0 (buf);
	_g_object_unref0 (sp);
	_g_object_unref0 (launcher);
	argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
	return result;
}

gchar**
terminal_fp_get_env (GCancellable* cancellable,
                     gint* result_length1,
                     GError** error)
{
	gchar** argv = NULL;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar** _tmp6_;
	gint argv_length1;
	gint _argv_size_;
	GSubprocessLauncher* launcher = NULL;
	GSubprocessLauncher* _tmp7_;
	GSubprocessLauncher* _tmp8_;
	GSubprocess* sp = NULL;
	GSubprocessLauncher* _tmp9_;
	gchar** _tmp10_;
	gint _tmp10__length1;
	GSubprocess* _tmp11_;
	GSubprocess* _tmp12_;
	gchar* buf = NULL;
	gboolean _tmp14_ = FALSE;
	GSubprocess* _tmp15_;
	gchar* _tmp16_ = NULL;
	gboolean _tmp17_;
	gchar** arr = NULL;
	const gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar** _tmp22_;
	gchar** _tmp23_;
	gchar** _tmp24_;
	gint _tmp24__length1;
	gint arr_length1;
	gint _arr_size_;
	gchar** _tmp25_;
	gint _tmp25__length1;
	GError* _inner_error0_ = NULL;
	gchar** result;
	if (!terminal_is_flatpak ()) {
		gchar** _tmp0_;
		gchar** _tmp1_;
		gchar** _tmp2_;
		gint _tmp2__length1;
		_tmp1_ = _tmp0_ = g_get_environ ();
		_tmp2_ = _tmp1_;
		_tmp2__length1 = _vala_array_length (_tmp0_);
		if (result_length1) {
			*result_length1 = _tmp2__length1;
		}
		result = _tmp2_;
		return result;
	}
	_tmp3_ = g_strdup ("flatpak-spawn");
	_tmp4_ = g_strdup ("--host");
	_tmp5_ = g_strdup ("env");
	_tmp6_ = g_new0 (gchar*, 3 + 1);
	_tmp6_[0] = _tmp3_;
	_tmp6_[1] = _tmp4_;
	_tmp6_[2] = _tmp5_;
	argv = _tmp6_;
	argv_length1 = 3;
	_argv_size_ = argv_length1;
	_tmp7_ = g_subprocess_launcher_new (G_SUBPROCESS_FLAGS_STDOUT_PIPE | G_SUBPROCESS_FLAGS_STDERR_SILENCE);
	launcher = _tmp7_;
	_tmp8_ = launcher;
	g_subprocess_launcher_setenv (_tmp8_, "G_MESSAGES_DEBUG", "false", TRUE);
	_tmp9_ = launcher;
	_tmp10_ = argv;
	_tmp10__length1 = argv_length1;
	_tmp11_ = g_subprocess_launcher_spawnv (_tmp9_, _tmp10_, &_inner_error0_);
	sp = _tmp11_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_object_unref0 (launcher);
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
		return NULL;
	}
	_tmp12_ = sp;
	if (_tmp12_ == NULL) {
		gchar** _tmp13_;
		gint _tmp13__length1;
		_tmp13_ = NULL;
		_tmp13__length1 = 0;
		if (result_length1) {
			*result_length1 = _tmp13__length1;
		}
		result = _tmp13_;
		_g_object_unref0 (sp);
		_g_object_unref0 (launcher);
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
		return result;
	}
	buf = NULL;
	_tmp15_ = sp;
	_tmp17_ = g_subprocess_communicate_utf8 (_tmp15_, NULL, cancellable, &_tmp16_, NULL, &_inner_error0_);
	_g_free0 (buf);
	buf = _tmp16_;
	_tmp14_ = _tmp17_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_free0 (buf);
		_g_object_unref0 (sp);
		_g_object_unref0 (launcher);
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
		return NULL;
	}
	if (!_tmp14_) {
		gchar** _tmp18_;
		gint _tmp18__length1;
		_tmp18_ = NULL;
		_tmp18__length1 = 0;
		if (result_length1) {
			*result_length1 = _tmp18__length1;
		}
		result = _tmp18_;
		_g_free0 (buf);
		_g_object_unref0 (sp);
		_g_object_unref0 (launcher);
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
		return result;
	}
	_tmp19_ = buf;
	_tmp20_ = string_strip (_tmp19_);
	_tmp21_ = _tmp20_;
	_tmp23_ = _tmp22_ = g_strsplit (_tmp21_, "\n", 0);
	_tmp24_ = _tmp23_;
	_tmp24__length1 = _vala_array_length (_tmp22_);
	_g_free0 (_tmp21_);
	arr = _tmp24_;
	arr_length1 = _tmp24__length1;
	_arr_size_ = arr_length1;
	_tmp25_ = arr;
	_tmp25__length1 = arr_length1;
	if (result_length1) {
		*result_length1 = _tmp25__length1;
	}
	result = _tmp25_;
	_g_free0 (buf);
	_g_object_unref0 (sp);
	_g_object_unref0 (launcher);
	argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
	return result;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

